/**
 * Created by xamidylin on 17.11.2014.
 */
'use strict';
(function (require, process) {
    var template = "module {{directiveModuleName}} {" + "\n" +
        "    export class {{directiveName}} {" +"\n" +
        "        static Name = '{{directiveNameLow}}';" +"\n" +
        "        static Directive = [{{directiveName}}.Name, () => new {{directiveName}}()];" +"\n" +
        "        private controller = undefined;" + "\n" +
        "        private controllerAs = undefined;" + "\n" +
        "        private restrict = 'EA';" +"\n" +
        "        private templateUrl = '/{{templatePath}}.html';" +"\n" +
        "        private link = ($scope,$element,$attr,ctrl) => {" +"\n" +
        "            " +"\n" +
        "        };" +"\n" +
        "    }" +"\n" +
        "}";
    var lessTemplate = "{{elementName}} {" +"\n" +
        "    " +"\n" +
        "}";
    var require;
    var fs = require('fs');
    var pathParam = "--path=", baseParam = "--base=", cwdParam = "--cwd=";
    var path = '';
    var base = ''
    var cwd = 'Modules'
    process.argv.forEach(function (val, index, array) {
        if (val.substr(0, pathParam.length) == pathParam) {
            path = val.substr(pathParam.length);
        }
        if (val.substr(0, baseParam.length) == baseParam) {
            base = val.substr(baseParam.length);
        }
        if (val.substr(0, cwdParam.length) == cwdParam) {
            cwd = val.substr(cwdParam.length);
        }
    });
    var delimeter = /[\/\\]/g;
    var split = path.split(delimeter);
    var directiveName = split.pop().split('.')[0];
    var directiveNameLow = directiveName[0].toLowerCase()+directiveName.substr(1);
    var directiveModuleName = ((base ? base + '.' : '') + split.join('.')).replace(cwd + '.', '');
    var templatePath = path.replace('Directives','Templates').replace(delimeter,'/');
    try {
        fs.writeFile(path+'.ts',
            template
                .replace(/{{directiveModuleName}}/g, directiveModuleName)
                .replace(/{{directiveName}}/g, directiveName)
                .replace(/{{directiveNameLow}}/g, directiveNameLow)
                .replace(/{{templatePath}}/g, templatePath)
        );
        fs.writeFile(path.replace('Directives','Templates')+'.html', '');
        fs.writeFile(path.replace('Directives','Css')+'.less', lessTemplate
            .replace(/{{elementName}}/g, directiveNameLow.match(/[A-Z]?[a-z]+/g).join('-').toLowerCase()));
    } catch (e) {
    }
})(require, process);